<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      size="small"
      :inline="true"
      v-show="showSearch"
      label-width="140px"
    >
      <el-form-item label="物资规格种类" prop="propertyName">
        <el-input
          v-model="queryParams.propertyName"
          placeholder="请输入物资规格种类"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item>
        <el-button
          v-no-more-click
          type="primary"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索
        </el-button>
        <el-button
          v-no-more-click
          icon="el-icon-refresh"
          size="mini"
          @click="resetQuery"
          >重置
        </el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          v-no-more-click
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['iscs:property:add']"
          >新增
        </el-button>
      </el-col>

      <el-col :span="1.5">
        <el-button
          v-no-more-click
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['iscs:property:remove']"
          >批量删除
        </el-button>
      </el-col>
      <right-toolbar
        :showSearch.sync="showSearch"
        @queryTable="getList"
      ></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="PropertyList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="编号" align="center" prop="propertyId">
      </el-table-column>
      <el-table-column
        label="物资规格种类"
        align="center"
        prop="propertyName"
      />
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="创建时间" align="center" prop="createTime" />
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            v-no-more-click
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['iscs:property:edit']"
            >修改
          </el-button>
          <el-button
            v-no-more-click
            size="mini"
            type="text"
            icon="el-icon-view"
            @click="handleValue(scope.row)"
            v-hasPermi="['iscs:property:edit']"
            >规格设置
          </el-button>
          <el-button
            v-no-more-click
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['iscs:property:remove']"
            >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>
    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.current"
      :limit.sync="queryParams.size"
      @pagination="getList"
    />
    <!-- 添加或修改物资对话框 -->
    <el-dialog :visible.sync="open" width="540px" append-to-body>
      <div slot="title" class="dialog-title">
        <i></i>
        <span class="title">{{ title }}</span>
      </div>
      <el-form ref="form" :model="form" :rules="rules" label-width="150px">
        <el-form-item label="物资规格种类" prop="propertyName">
          <el-input
            style="width: 350px"
            v-model="form.propertyName"
            placeholder="请输入物资规格种类"
          />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input
            type="textarea"
            style="width: 350px"
            v-model="form.remark"
            placeholder="请输入内容"
          />
        </el-form-item>
      </el-form>

      <div slot="footer" class="dialog-footer">
        <el-button v-no-more-click type="primary" @click="submitForm"
          >确 定
        </el-button>
        <el-button v-no-more-click @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  PropertyPage,
  addProperty,
  updateProperty,
  deleteProperty,
  selectPropertyById,
} from "@/api/mes/standard/index";

import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

import Template from "@/views/print/printtemplate/list.vue";

export default {
  name: "Team",
  components: {
    Template,
    Treeselect,
  },
  dicts: ["material_status", "file_type"],
  data() {
    return {
      //自动生成编码
      autoGenFlag: false,
      optType: undefined,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      codes: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 班组表格数据
      PropertyList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      createTime: "",
      queryParams: {
        current: 1,
        size: 10,
        propertyName: "",
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        propertyName: [
          { required: true, message: "名称不能为空", trigger: "blur" },
        ],
        materialsTypeId: [
          { required: true, message: "物资类型不能为空", trigger: "blur" },
        ],
      },
    };
  },
  created() {
    this.getList();
  },

  methods: {
    /** 查询物资信息列表 */
    getList() {
      this.loading = true;
      PropertyPage(this.queryParams).then((response) => {
        console.log(response, "获取物资说明 ");
        this.PropertyList = response.data.records;
        this.total = response.data.total;

        this.loading = false;
      });
    },
    // 跳转属性值页面
    handleValue(row) {
      this.$router.push({
        name: "propertyForm",
        query: { propertyId: row.propertyId, propertyName: row.propertyName },
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        propertyName: "",
      };
      this.resetForm("form");
      this.autoGenFlag = false;
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.propertyId);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },

    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "新增物资规格种类";
      this.optType = "add";
    },

    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      selectPropertyById(row.propertyId).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改物资规格种类";
        this.optType = "edit";
      });
    },

    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.propertyId != null) {
            updateProperty(this.form).then((response) => {
              console.log(response, "修改返回");
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            console.log(this.form, "新增参数");
            addProperty(this.form).then((response) => {
              console.log(response, "新增返回");
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },

    /** 删除按钮操作 */
    // confirm('是否确认删除编号为"' + propertyId + '"的数据项？')
    handleDelete(row) {
      const propertyId = row.propertyId || this.ids;
      this.$modal
        .confirm("是否确认删除所选数据项？")
        .then(function () {
          return deleteProperty(propertyId);
        })
        .then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
  },
};
</script>
<style lang="scss" src="@/assets/styles/dialog-title.scss" scoped>
.el-input-width {
  width: 380px !important;
}
</style>
